diff --git a/src/main/java/net/minecraft/server/world/WorldServer.java b/src/main/java/net/minecraft/server/world/WorldServer.java
index 51f4021fe..d691573ab 100644
--- a/src/main/java/net/minecraft/server/world/WorldServer.java
+++ b/src/main/java/net/minecraft/server/world/WorldServer.java
@@ -4,13 +4,13 @@ import java.util.ArrayList;
 import java.util.List;
 
 import net.minecraft.core.Global;
+import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.entity.animal.Animal;
+import net.minecraft.core.util.collection.IntHashMap;
 import net.minecraft.core.world.*;
-import net.minecraft.core.world.pathfinder.IdHashMap;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.animal.EntityAnimal;
-import net.minecraft.core.entity.player.EntityPlayer;
-import net.minecraft.core.entity.animal.EntityWaterAnimal;
-import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.entity.animal.WaterAnimal;
 import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.net.packet.*;
@@ -22,11 +22,11 @@ import net.minecraft.core.world.type.WorldType;
 import net.minecraft.server.MinecraftServer;
 
 // Referenced classes of package net.minecraft.src:
-//            World, WorldProvider, MCHash, EntityAnimal, 
-//            EntityWaterMob, Entity, EntityPlayer, ISaveHandler, 
-//            ChunkProviderServer, TileEntity, WorldInfo, MathHelper, 
-//            ServerConfigurationManager, Packet71Weather, Packet38EntityStatus, EntityTracker, 
-//            Explosion, Packet60Explosion, Packet54PlayNoteBlock, Packet70Bed, 
+//            World, WorldProvider, MCHash, Animal,
+//            EntityWaterMob, Entity, Player, ISaveHandler,
+//            ChunkProviderServer, BlockEntity, WorldInfo, MathHelper,
+//            ServerConfigurationManager, WeatherEffectPacket, EnitityEventPacket, EntityTracker,
+//            Explosion, ExplosionPacket, BlockEventPacket, BedMessagePacket,
 //            IChunkProvider
 
 public class WorldServer extends World
@@ -36,18 +36,18 @@ public class WorldServer extends World
     {
         super(isavehandler, name, seed, Dimension.getDimensionList().get(dimensionId), worldType);
         field_819_z = false;
-        entityIdHashMap = new IdHashMap<>();
+        entityIntHashMap = new IntHashMap<>();
         mcServer = minecraftserver;
     }
 
     @Override
     public void updateEntityWithOptionalForce(Entity entity, boolean flag)
     {
-        if(!mcServer.spawnPeacefulMobs && ((entity instanceof EntityAnimal) || (entity instanceof EntityWaterAnimal)))
+        if(!mcServer.spawnPeacefulMobs && ((entity instanceof Animal) || (entity instanceof WaterAnimal)))
         {
             entity.remove();
         }
-        if(!(entity.passenger instanceof EntityPlayer))
+        if(!(entity.passenger instanceof Player))
         {
             super.updateEntityWithOptionalForce(entity, flag);
         }
@@ -66,12 +66,12 @@ public class WorldServer extends World
         return chunkProviderServer;
     }
 
-    public List<TileEntity> getTileEntityList(int i, int j, int k, int l, int i1, int j1)
+    public List<BlockEntity> getTileEntityList(int i, int j, int k, int l, int i1, int j1)
     {
-        ArrayList<TileEntity> arraylist = new ArrayList<>();
-        for(int k1 = 0; k1 < loadedTileEntityList.size(); k1++)
+        ArrayList<BlockEntity> arraylist = new ArrayList<>();
+        for(int k1 = 0; k1 < loadedBlockEntityList.size(); k1++)
         {
-            TileEntity tileentity = loadedTileEntityList.get(k1);
+            BlockEntity tileentity = loadedBlockEntityList.get(k1);
             if(tileentity.x >= i && tileentity.y >= j && tileentity.z >= k && tileentity.x < l && tileentity.y < i1 && tileentity.z < j1)
             {
                 arraylist.add(tileentity);
@@ -82,7 +82,7 @@ public class WorldServer extends World
     }
 
     @Override
-    public boolean canMineBlock(EntityPlayer entityplayer, int i, int j, int k)
+    public boolean canMineBlock(Player entityplayer, int i, int j, int k)
     {
         int l = (int)MathHelper.abs(i - levelData.getSpawnX());
         int i1 = (int)MathHelper.abs(k - levelData.getSpawnZ());
@@ -98,7 +98,7 @@ public class WorldServer extends World
     {
         super.obtainEntitySkin(entity);
         if (entity == null) return;
-        entityIdHashMap.add(entity.id, entity);
+        entityIntHashMap.put(entity.id, entity);
     }
 
     @Override
@@ -106,7 +106,7 @@ public class WorldServer extends World
     {
         super.releaseEntitySkin(entity);
         if (entity == null) return;
-        entityIdHashMap.remove(entity.id);
+        entityIntHashMap.remove(entity.id);
     }
 
     @Override
@@ -122,14 +122,14 @@ public class WorldServer extends World
             {
                 if(MinecraftServer.getInstance() != null && players.size() > 1) {
                     if(getPlayersRequiredToSkipNight() <= 1) {
-                        EntityPlayer player = null;
-                        for(EntityPlayer player2 : players) {
+                        Player player = null;
+                        for(Player player2 : players) {
                             if(player2.isPlayerFullyAsleep()) {
                                 player = player2;
                             }
                         }
                         if(player != null) {
-                            MinecraftServer.getInstance().playerList.sendPacketToAllPlayersInDimension(new Packet3Chat(TextFormatting.YELLOW + player.getDisplayName() + TextFormatting.ORANGE + " went to sleep. Sweet dreams!"), dimension.id);
+                            MinecraftServer.getInstance().playerList.sendPacketToAllPlayersInDimension(new ChatPacket(TextFormatting.YELLOW + player.getDisplayName() + TextFormatting.ORANGE + " went to sleep. Sweet dreams!"), dimension.id);
                         }
                     }
                 }
@@ -142,13 +142,13 @@ public class WorldServer extends World
     }
 
     @Override
-    public void updateEnoughPlayersSleepingFlag(EntityPlayer player)
+    public void updateEnoughPlayersSleepingFlag(Player player)
     {
         enoughPlayersSleeping = false;
         if(players.size() > 0) {
             int playersSleeping = 0;
             int req = getPlayersRequiredToSkipNight();
-            for(EntityPlayer p : players)
+            for(Player p : players)
                 if(p.isPlayerSleeping()) playersSleeping++;
             if(playersSleeping >= req) {
                 enoughPlayersSleeping = true;
@@ -157,15 +157,15 @@ public class WorldServer extends World
             if(MinecraftServer.getInstance() != null && player != null && players.size() > 1 && req > 1) {
                 int moreReq = req - playersSleeping;
                 if(player.isPlayerSleeping()) {
-                    MinecraftServer.getInstance().playerList.sendPacketToAllPlayersInDimension(new Packet3Chat(TextFormatting.YELLOW + player.username + TextFormatting.ORANGE + " went to bed."), dimension.id);
+                    MinecraftServer.getInstance().playerList.sendPacketToAllPlayersInDimension(new ChatPacket(TextFormatting.YELLOW + player.username + TextFormatting.ORANGE + " went to bed."), dimension.id);
                 }else {
-                    MinecraftServer.getInstance().playerList.sendPacketToAllPlayersInDimension(new Packet3Chat(TextFormatting.YELLOW + player.username + TextFormatting.ORANGE + " has left their bed."), dimension.id);
+                    MinecraftServer.getInstance().playerList.sendPacketToAllPlayersInDimension(new ChatPacket(TextFormatting.YELLOW + player.username + TextFormatting.ORANGE + " has left their bed."), dimension.id);
                 }
                 if(moreReq > 0) {
                     if(moreReq > 1) {
-                        MinecraftServer.getInstance().playerList.sendPacketToAllPlayersInDimension(new Packet3Chat(TextFormatting.LIGHT_GRAY + "" + moreReq + " more players are required to sleep to skip to daytime"), dimension.id);
+                        MinecraftServer.getInstance().playerList.sendPacketToAllPlayersInDimension(new ChatPacket(TextFormatting.LIGHT_GRAY + "" + moreReq + " more players are required to sleep to skip to daytime"), dimension.id);
                     }else {
-                        MinecraftServer.getInstance().playerList.sendPacketToAllPlayersInDimension(new Packet3Chat(TextFormatting.LIGHT_GRAY + "1 more player is required to sleep to skip to daytime"), dimension.id);
+                        MinecraftServer.getInstance().playerList.sendPacketToAllPlayersInDimension(new ChatPacket(TextFormatting.LIGHT_GRAY + "1 more player is required to sleep to skip to daytime"), dimension.id);
                     }
 
                 }
@@ -176,7 +176,7 @@ public class WorldServer extends World
 
     public Entity getEntityFromId(int i)
     {
-        return entityIdHashMap.get(i);
+        return entityIntHashMap.get(i);
     }
 
     @Override
@@ -184,7 +184,7 @@ public class WorldServer extends World
     {
         if(super.addWeatherEffect(entity))
         {
-            mcServer.playerList.sendPacketToPlayersAroundPoint(entity.x, entity.y, entity.z, 512D, dimension.id, new Packet71Weather(entity));
+            mcServer.playerList.sendPacketToPlayersAroundPoint(entity.x, entity.y, entity.z, 512D, dimension.id, new WeatherEffectPacket(entity));
             return true;
         } else
         {
@@ -195,21 +195,21 @@ public class WorldServer extends World
     @Override
     public void sendTrackedEntityStatusUpdatePacket(Entity entityId, byte entityStatus)
     {
-        Packet38EntityStatus packet38entitystatus = new Packet38EntityStatus(entityId.id, entityStatus);
-        mcServer.getEntityTracker(dimension.id).sendPacketToTrackedPlayersAndTrackedEntity(entityId, packet38entitystatus);
+        EnitityEventPacket enitityEventPacket38Entitystatus = new EnitityEventPacket(entityId.id, entityStatus);
+        mcServer.getEntityTracker(dimension.id).sendPacketToTrackedPlayersAndTrackedEntity(entityId, enitityEventPacket38Entitystatus);
     }
 
     @Override
     public void sendTrackedEntityStatusUpdatePacket(Entity entityId, byte entityStatus, float attackedAtYaw)
     {
-        Packet38EntityStatus packet38entitystatus = new Packet38EntityStatus(entityId.id, entityStatus, attackedAtYaw);
-        mcServer.getEntityTracker(dimension.id).sendPacketToTrackedPlayersAndTrackedEntity(entityId, packet38entitystatus);
+        EnitityEventPacket enitityEventPacket38Entitystatus = new EnitityEventPacket(entityId.id, entityStatus, attackedAtYaw);
+        mcServer.getEntityTracker(dimension.id).sendPacketToTrackedPlayersAndTrackedEntity(entityId, enitityEventPacket38Entitystatus);
     }
 
     @Override
     public void sendTrackedEntityDataPacket(Entity entity) {
-        Packet42EntityTagData packet42entitytagdata = new Packet42EntityTagData(entity);
-        mcServer.getEntityTracker(dimension.id).sendPacketToTrackedPlayersAndTrackedEntity(entity, packet42entitytagdata);
+        EntityTagDataPacket entitytagdataNBT = new EntityTagDataPacket(entity);
+        mcServer.getEntityTracker(dimension.id).sendPacketToTrackedPlayersAndTrackedEntity(entity, entitytagdataNBT);
     }
 
     @Override
@@ -225,16 +225,16 @@ public class WorldServer extends World
         else
             explosion = new ExplosionCannonball(this, entity, x, y, z, explosionSize);
         explosion.isFlaming = flaming;
-        explosion.doExplosionA();
-        explosion.doExplosionB(true);
-        mcServer.playerList.sendPacketToPlayersAroundPoint(x, y, z, 64D, dimension.id, new Packet60Explosion(x, y, z, explosionSize, explosion.destroyedBlockPositions, isCannonBall));
+        explosion.explode();
+        explosion.addEffects(true);
+        mcServer.playerList.sendPacketToPlayersAroundPoint(x, y, z, 64D, dimension.id, new ExplosionPacket(x, y, z, explosionSize, explosion.destroyedBlockPositions, isCannonBall));
         return explosion;
     }
     @Override
     public void triggerEvent(int x, int y, int z, int index, int data)
     {
         super.triggerEvent(x, y, z, index, data);
-        mcServer.playerList.sendPacketToPlayersAroundPoint(x, y, z, 64D, dimension.id, new Packet54PlayNoteBlock(x, y, z, index, data));
+        mcServer.playerList.sendPacketToPlayersAroundPoint(x, y, z, 64D, dimension.id, new BlockEventPacket(x, y, z, index, data));
     }
 
     public void func_30006_w()
@@ -247,19 +247,19 @@ public class WorldServer extends World
         super.tick();
 
         if (System.currentTimeMillis() - lastWeatherSend > 1000) {
-            mcServer.playerList.sendPacketToAllPlayers(new Packet73WeatherStatus(dimension.id, getCurrentWeather() != null ? getCurrentWeather().weatherId : -1, weatherManager.getNextWeather() != null ? weatherManager.getNextWeather().weatherId : -1, weatherManager.getWeatherDuration(), weatherManager.getWeatherIntensity(), weatherManager.getWeatherPower()));
+            mcServer.playerList.sendPacketToAllPlayers(new WeatherStatusPacket(dimension.id, getCurrentWeather() != null ? getCurrentWeather().weatherId : -1, weatherManager.getNextWeather() != null ? weatherManager.getNextWeather().weatherId : -1, weatherManager.getWeatherDuration(), weatherManager.getWeatherIntensity(), weatherManager.getWeatherPower()));
             lastWeatherSend = System.currentTimeMillis();
         }
     }
     @Override
     public void sendGlobalMessage(String message){
-        mcServer.playerList.sendPacketToAllPlayers(new Packet3Chat(message));
+        mcServer.playerList.sendPacketToAllPlayers(new ChatPacket(message));
     }
 
     public ChunkProviderServer chunkProviderServer;
     public boolean field_819_z;
     public boolean levelSaving;
     public MinecraftServer mcServer;
-    private final IdHashMap<Entity> entityIdHashMap;
+    private final IntHashMap<Entity> entityIntHashMap;
     private long lastWeatherSend = System.currentTimeMillis();
 }
diff --git a/src/main/java/org/lwjgl/opengl/Display.java b/src/main/java/org/lwjgl/opengl/Display.java
new file mode 100644
index 000000000..30ee29765
--- /dev/null
+++ b/src/main/java/org/lwjgl/opengl/Display.java
@@ -0,0 +1,301 @@
+package org.lwjgl.opengl;
+
+import org.lwjgl.BufferUtils;
+import org.lwjgl.LWJGLException;
+import org.lwjgl.glfw.*;
+import org.lwjgl.input.Keyboard;
+import org.lwjgl.input.Mouse;
+
+import java.awt.*;
+import java.nio.Buffer;
+import java.nio.ByteBuffer;
+
+public abstract class Display {
+    private static String title = "";
+    private static long handle = -1;
+    private static boolean resizable = false;
+    private static DisplayMode displayMode = new DisplayMode(640, 480, 24, 60);
+    private static int width = 0;
+    private static int height = 0;
+    private static int xPos = 0;
+    private static int yPos = 0;
+    private static boolean windowResized = false;
+    private static GLFWWindowSizeCallback sizeCallback = null;
+    private static ByteBuffer[] cachedIcons = null;
+    private static Canvas parent = null;
+
+    public static void create() throws LWJGLException {
+        create(new PixelFormat());
+    }
+
+    public static long getHandle() {
+        return handle;
+    }
+
+    public static void create(PixelFormat pixel_format) throws LWJGLException {
+        GLFWErrorCallback.createPrint(System.err).set();
+        if (!GLFW.glfwInit()) {
+            throw new IllegalStateException("Unable to initialize GLFW");
+        }
+        GLFW.glfwDefaultWindowHints();
+        GLFW.glfwWindowHint(GLFW.GLFW_VISIBLE, GLFW.GLFW_FALSE);
+        GLFW.glfwWindowHint(GLFW.GLFW_RESIZABLE, resizable ? GLFW.GLFW_TRUE : GLFW.GLFW_FALSE);
+        handle = GLFW.glfwCreateWindow(displayMode.getWidth(), displayMode.getHeight(), title, 0, 0);
+        width = displayMode.getWidth();
+        height = displayMode.getHeight();
+        GLFW.glfwMakeContextCurrent(handle);
+        GL.createCapabilities();
+        sizeCallback = GLFWWindowSizeCallback.create(Display::resizeCallback);
+        GLFW.glfwSetWindowSizeCallback(handle, sizeCallback);
+        Mouse.create();
+        Keyboard.create();
+        GLFW.glfwShowWindow(handle);
+        if (cachedIcons != null) {
+            setIcon(cachedIcons);
+        }
+    }
+
+    private static void resizeCallback(long window, int width, int height) {
+        if (window == handle) {
+            Display.width = width;
+            Display.height = height;
+            windowResized = true;
+        }
+    }
+
+    private static void destroyWindow() {
+        sizeCallback.free();
+        Mouse.destroy();
+        Keyboard.destroy();
+        GLFW.glfwDestroyWindow(handle);
+    }
+
+    public static void destroy() {
+        destroyWindow();
+        GLFW.glfwTerminate();
+        GLFW.glfwSetErrorCallback(null).free();
+    }
+
+    public static DisplayMode[] getAvailableDisplayModes() {
+        long primaryMonitor = GLFW.glfwGetPrimaryMonitor();
+        if (primaryMonitor == 0) {
+            return new DisplayMode[0];
+        }
+        GLFWVidMode.Buffer videoModes = GLFW.glfwGetVideoModes(primaryMonitor);
+        if (videoModes == null) {
+            return new DisplayMode[0];
+        }
+
+        DisplayMode[] modes = new DisplayMode[videoModes.capacity()];
+        for (int i = 0; i < videoModes.capacity(); i++) {
+            GLFWVidMode videoMode = videoModes.get(i);
+            modes[i] = new DisplayMode(videoMode.width(), videoMode.height(), videoMode.redBits() + videoMode.greenBits() + videoMode.blueBits(), videoMode.refreshRate());
+        }
+        return modes;
+    }
+
+    public static DisplayMode getDesktopDisplayMode() {
+        GLFWVidMode videoMode = GLFW.glfwGetVideoMode(GLFW.glfwGetPrimaryMonitor());
+        if (videoMode == null) {
+            DisplayMode[] displayModes = getAvailableDisplayModes();
+            if (displayModes.length == 0) {
+                return null;
+            }
+            DisplayMode largest = displayModes[0];
+            for (DisplayMode mode : displayModes) {
+                if (mode.getWidth() * mode.getHeight() > largest.getWidth() * largest.getHeight()) {
+                    largest = mode;
+                }
+            }
+
+            return largest;
+        } else {
+            return new DisplayMode(videoMode.width(), videoMode.height(), videoMode.redBits() + videoMode.greenBits() + videoMode.blueBits(), videoMode.refreshRate());
+        }
+    }
+
+    public static DisplayMode getDisplayMode() {
+        return displayMode;
+    }
+
+    public static int getHeight() {
+        return height;
+    }
+
+    public static Canvas getParent() {
+        return parent;
+    }
+
+    public static String getTitle() {
+        return title;
+    }
+
+    public static int getWidth() {
+        return width;
+    }
+
+    public static int getX() {
+        return xPos;
+    }
+
+    public static int getY() {
+        return yPos;
+    }
+
+    public static boolean isActive() {
+        return GLFW.glfwGetWindowAttrib(handle, GLFW.GLFW_FOCUSED) == GLFW.GLFW_TRUE;
+    }
+
+    public static boolean isCloseRequested() {
+        return GLFW.glfwWindowShouldClose(handle);
+    }
+
+    public static boolean isCreated() {
+        return handle != -1;
+    }
+
+    public static boolean isFullscreen() {
+        return GLFW.glfwGetWindowMonitor(handle) != 0;
+    }
+
+    public static boolean isResizable() {
+        return resizable;
+    }
+
+    public static boolean isVisible() {
+        return GLFW.glfwGetWindowAttrib(handle, GLFW.GLFW_VISIBLE) == GLFW.GLFW_TRUE;
+    }
+
+    public static void setDisplayMode(DisplayMode mode) throws LWJGLException {
+        displayMode = mode;
+        if (isCreated()) {
+            GLFW.glfwSetWindowSize(handle, mode.getWidth(), mode.getHeight());
+        }
+    }
+
+    public static void setDisplayModeAndFullscreen(DisplayMode mode) throws LWJGLException {
+        setDisplayMode(mode);
+        setFullscreen(true);
+    }
+
+    public static void setFullscreen(boolean fullscreen) throws LWJGLException {
+        try {
+            resizeCallback(handle, displayMode.getWidth(), displayMode.getHeight());
+            if (fullscreen) {
+                long monitor = GLFW.glfwGetPrimaryMonitor();
+
+                GLFW.glfwSetWindowMonitor(
+                    handle,
+                    monitor,
+                    0,
+                    0,
+                    getWidth(),
+                    getHeight(),
+                    displayMode.getFrequency()
+                );
+                xPos = displayMode.getWidth() / 2;
+                yPos = displayMode.getHeight() / 2;
+            } else {
+                xPos -= width / 2;
+                yPos -= height / 2;
+                GLFW.glfwSetWindowMonitor(
+                    handle,
+                    0L,
+                    xPos,
+                    yPos,
+                    getWidth(),
+                    getHeight(),
+                    -1
+                );
+            }
+            GLFW.glfwSetWindowSize(handle, getWidth(), getHeight());
+        } catch (Exception e) {
+            e.printStackTrace();
+        }
+    }
+
+    public static int setIcon(ByteBuffer[] icons) {
+        if (isCreated()) {
+            GLFW.glfwSetWindowIcon(handle, iconsToGLFWBuffer(icons));
+            return 1;
+        } else {
+            return 0;
+        }
+    }
+
+    private static ByteBuffer cloneByteBuffer(ByteBuffer original) {
+        ByteBuffer clone = BufferUtils.createByteBuffer(original.capacity());
+        int oldPosition = original.position();
+        clone.put(original);
+        ((Buffer) original).position(oldPosition);
+        ((Buffer) clone).flip();
+
+        return clone;
+    }
+
+    private static GLFWImage.Buffer iconsToGLFWBuffer(ByteBuffer[] icons) {
+        GLFWImage.Buffer buffer = GLFWImage.create(icons.length);
+        for (ByteBuffer icon : icons) {
+            int size = icon.limit() / 4;
+            int dimension = (int)(Math.sqrt(size));
+            GLFWImage image = GLFWImage.malloc();
+            buffer.put(image.set(dimension, dimension, icon));
+        }
+        buffer.flip();
+        return buffer;
+    }
+
+    public static void setLocation(int x, int y) {
+        xPos = x;
+        yPos = y;
+        if (isCreated()) {
+            GLFW.glfwSetWindowPos(handle, x, y);
+        }
+    }
+
+    public static void setParent(Canvas parent) throws LWJGLException {
+        Display.parent = parent;
+    }
+
+    public static void setResizable(boolean resizable) {
+        Display.resizable = resizable;
+        if (isCreated()) {
+            GLFW.glfwSetWindowAttrib(handle, GLFW.GLFW_RESIZABLE, resizable ? GLFW.GLFW_TRUE : GLFW.GLFW_FALSE);
+        }
+    }
+
+    public static void setSwapInterval(int interval) {
+        GLFW.glfwSwapInterval(interval);
+    }
+
+    public static void setTitle(String title) {
+        Display.title = title;
+        if (isCreated()) {
+            GLFW.glfwSetWindowTitle(handle, title);
+        }
+    }
+
+    public static void setVSyncEnabled(boolean sync) {
+        setSwapInterval(sync ? 1 : 0);
+    }
+
+    public static void swapBuffers() throws LWJGLException {
+        GLFW.glfwSwapBuffers(handle);
+    }
+
+    public static void update() {
+        windowResized = false;
+        GLFW.glfwPollEvents();
+        if (Mouse.isCreated()) {
+            Mouse.poll();
+        }
+        if (Keyboard.isCreated()) {
+            Keyboard.poll();
+        }
+        GLFW.glfwSwapBuffers(handle);
+    }
+
+    public static boolean wasResized() {
+        return windowResized;
+    }
+}
diff --git a/src/main/resources/assets/minecraft/textures/environment/aurora.png.mcmeta b/src/main/resources/assets/minecraft/textures/environment/aurora.png.mcmeta
new file mode 100644
index 000000000..7275ccde7
--- /dev/null
+++ b/src/main/resources/assets/minecraft/textures/environment/aurora.png.mcmeta
@@ -0,0 +1,5 @@
+{
+    "texture": {
+        "blur": true
+    }
+}
\ No newline at end of file
diff --git a/src/main/resources/assets/minecraft/textures/gui/sprites/widgets/button.png.mcmeta b/src/main/resources/assets/minecraft/textures/gui/sprites/widgets/button.png.mcmeta
new file mode 100644
index 000000000..a9b84c3cb
--- /dev/null
+++ b/src/main/resources/assets/minecraft/textures/gui/sprites/widgets/button.png.mcmeta
@@ -0,0 +1,13 @@
+{
+    "gui": {
+        "type": "nine_slice",
+        "width": 200,
+        "height": 20,
+        "border": {
+            "top": 2,
+            "left": 2,
+            "right": 2,
+            "bottom": 3
+        }
+    }
+}
\ No newline at end of file
diff --git a/src/main/resources/assets/minecraft/textures/gui/sprites/widgets/button_disabled.png.mcmeta b/src/main/resources/assets/minecraft/textures/gui/sprites/widgets/button_disabled.png.mcmeta
new file mode 100644
index 000000000..a08c3403a
--- /dev/null
+++ b/src/main/resources/assets/minecraft/textures/gui/sprites/widgets/button_disabled.png.mcmeta
@@ -0,0 +1,8 @@
+{
+    "gui": {
+        "type": "nine_slice",
+        "width": 200,
+        "height": 20,
+        "border": 1
+    }
+}
\ No newline at end of file
diff --git a/src/main/resources/assets/minecraft/textures/gui/sprites/widgets/button_highlighted.png.mcmeta b/src/main/resources/assets/minecraft/textures/gui/sprites/widgets/button_highlighted.png.mcmeta
new file mode 100644
index 000000000..a9b84c3cb
--- /dev/null
+++ b/src/main/resources/assets/minecraft/textures/gui/sprites/widgets/button_highlighted.png.mcmeta
@@ -0,0 +1,13 @@
+{
+    "gui": {
+        "type": "nine_slice",
+        "width": 200,
+        "height": 20,
+        "border": {
+            "top": 2,
+            "left": 2,
+            "right": 2,
+            "bottom": 3
+        }
+    }
+}
\ No newline at end of file
diff --git a/src/main/resources/assets/minecraft/textures/misc/pumpkinblur.png.mcmeta b/src/main/resources/assets/minecraft/textures/misc/pumpkinblur.png.mcmeta
new file mode 100644
index 000000000..7275ccde7
--- /dev/null
+++ b/src/main/resources/assets/minecraft/textures/misc/pumpkinblur.png.mcmeta
@@ -0,0 +1,5 @@
+{
+    "texture": {
+        "blur": true
+    }
+}
\ No newline at end of file
diff --git a/src/main/resources/assets/minecraft/textures/misc/shadow.png.mcmeta b/src/main/resources/assets/minecraft/textures/misc/shadow.png.mcmeta
new file mode 100644
index 000000000..5f42481dd
--- /dev/null
+++ b/src/main/resources/assets/minecraft/textures/misc/shadow.png.mcmeta
@@ -0,0 +1,5 @@
+{
+    "texture": {
+        "clamp": true
+    }
+}
\ No newline at end of file
diff --git a/src/main/resources/assets/minecraft/textures/misc/vignette.png.mcmeta b/src/main/resources/assets/minecraft/textures/misc/vignette.png.mcmeta
new file mode 100644
index 000000000..7275ccde7
--- /dev/null
+++ b/src/main/resources/assets/minecraft/textures/misc/vignette.png.mcmeta
@@ -0,0 +1,5 @@
+{
+    "texture": {
+        "blur": true
+    }
+}
\ No newline at end of file
diff --git a/src/main/resources/items.tiles b/src/main/resources/items.tiles
new file mode 100644
index 000000000..2c1e08358
--- /dev/null
+++ b/src/main/resources/items.tiles
@@ -0,0 +1,183 @@
+size=32x32
+0,0=armor_helmet_leather
+0,1=armor_chestplate_leather
+0,2=armor_leggings_leather
+0,3=armor_boots_leather
+0,4=tool_sword_wood
+0,5=tool_shovel_wood
+0,6=tool_pickaxe_wood
+0,7=tool_axe_wood
+0,8=tool_hoe_wood
+0,9=tool_sword_steel
+0,10=tool_shovel_steel
+0,11=tool_pickaxe_steel
+0,12=tool_axe_steel
+0,13=tool_hoe_steel
+0,15=record_13
+1,0=armor_helmet_chainmail
+1,1=armor_chestplate_chainmail
+1,2=armor_leggings_chainmail
+1,3=armor_boots_chainmail
+1,4=tool_sword_stone
+1,5=tool_shovel_stone
+1,6=tool_pickaxe_stone
+1,7=tool_axe_stone
+1,8=tool_hoe_stone
+1,9=armor_helmet_steel
+1,10=armor_chestplate_steel
+1,11=armor_leggings_steel
+1,12=armor_boots_steel
+1,15=record_cat
+2,0=armor_helmet_iron
+2,1=armor_chestplate_iron
+2,2=armor_leggings_iron
+2,3=armor_boots_iron
+2,4=tool_sword_iron
+2,5=tool_shovel_iron
+2,6=tool_pickaxe_iron
+2,7=tool_axe_iron
+2,8=tool_hoe_iron
+2,9=tool_shears_steel
+2,10=tool_firestriker_steel
+2,15=record_blocks
+3,0=armor_helmet_diamond
+3,1=armor_chestplate_diamond
+3,2=armor_leggings_diamond
+3,3=armor_boots_diamond
+3,4=tool_sword_diamond
+3,5=tool_shovel_diamond
+3,6=tool_pickaxe_diamond
+3,7=tool_axe_diamond
+3,8=tool_hoe_diamond
+3,9=jar
+3,10=lantern_firefly_green
+3,11=lantern_firefly_blue
+3,12=lantern_firefly_orange
+3,13=lantern_firefly_red
+3,15=record_chirp
+4,0=armor_helmet_gold
+4,1=armor_chestplate_gold
+4,2=armor_leggings_gold
+4,3=armor_boots_gold
+4,4=tool_sword_gold
+4,5=tool_shovel_gold
+4,6=tool_pickaxe_gold
+4,7=tool_axe_gold
+4,8=tool_hoe_gold
+4,9=armor_quiver_gold
+4,10=ammo_arrow_purple
+4,15=record_far
+5,0=tool_firestriker
+5,1=tool_bow
+5,2=ammo_arrow
+5,3=stick
+5,4=tool_fishingrod
+5,5=tool_fishingrod_cast
+5,6=nethercoal
+5,7=ammo_arrow_gold
+5,8=handcannon_unloaded
+5,9=handcannon_loaded
+5,15=record_mall
+6,0=flint
+6,1=brick_clay
+6,2=armor_quiver
+6,3=tool_compass
+6,4=tool_clock
+6,5=repeater
+6,6=armor_boots_iceskates
+6,7=tool_calendar
+6,8=ammo_charge_explosive
+6,9=armor_quiver_full
+6,15=record_mellohi
+7,0=coal
+7,1=ingot_iron
+7,2=ingot_gold
+7,3=diamond
+7,4=bowl
+7,5=food_porkchop_raw
+7,6=leather
+7,7=ingot_steel
+7,8=minecart
+7,9=minecart_chest
+7,10=minecart_furnace
+7,15=record_stal
+8,0=string
+8,1=feather_chicken
+8,2=sulphur
+8,3=dust_redstone
+8,4=food_stew_mushroom
+8,5=food_porkchop_cooked
+8,6=saddle
+8,7=ingot_steel_crude
+8,8=boat
+8,9=label
+8,10=label_written
+8,15=record_strad
+9,0=seeds_wheat
+9,1=wheat
+9,2=food_bread
+9,3=clay
+9,4=dust_glowstone
+9,5=food_fish_raw
+9,6=cloth
+9,7=chainlink
+9,8=ore_raw_iron
+9,15=record_ward
+10,0=food_apple
+10,1=painting
+10,2=sign
+10,3=paper
+10,4=bucket
+10,5=food_fish_cooked
+10,6=ammo_pebble
+10,7=food_cherry
+10,8=ore_raw_gold
+11,0=food_apple_gold
+11,1=sugarcane
+11,2=door_oak
+11,3=book
+11,4=bucket_water
+11,5=quartz
+11,6=olivine
+11,7=charcoal
+11,8=flag
+11,15=record_dog
+12,0=egg_chicken
+12,1=bone
+12,2=door_iron
+12,3=map
+12,4=bucket_lava
+12,5=food_cookie
+12,6=bucket_icecream
+12,7=basket
+12,8=seeds_pumpkin
+12,15=record_wait
+13,0=dust_sugar
+13,1=food_cake
+13,2=bed
+13,4=bucket_milk
+13,5=tool_shears
+14,0=ammo_snowball
+14,1=slimeball
+14,2=ammo_fireball
+14,3=seat
+14,4=dye_black
+14,5=dye_red
+14,6=dye_green
+14,7=dye_brown
+14,8=dye_blue
+14,9=dye_purple
+14,10=dye_cyan
+14,11=dye_silver
+15,0=armor_helmet_outline
+15,1=armor_chestplate_outline
+15,2=armor_leggings_outline
+15,3=armor_boots_outline
+15,4=dye_gray
+15,5=dye_pink
+15,6=dye_lime
+15,7=dye_yellow
+15,8=dye_lightblue
+15,9=dye_magenta
+15,10=dye_orange
+15,11=dye_white
\ No newline at end of file
